
#ifndef LEDEMBEDDED_HH
#define LEDEMBEDDED_HH

#include "LED.hh"
#include "Switch.hh"
#include "umlrtcapsule.hh"
#include "umlrtcapsuleclass.hh"
#include "umlrtmessage.hh"
#include "umlrttimerprotocol.hh"
struct UMLRTCommsPort;
struct UMLRTSlot;

class Capsule_LEDEmbedded : public UMLRTCapsule
{
public:
    Capsule_LEDEmbedded( const UMLRTCapsuleClass * cd, UMLRTSlot * st, const UMLRTCommsPort * * border, const UMLRTCommsPort * * internal, bool isStat );
protected:
    LED::Base lED;
public:
    enum BorderPortId
    {
        borderport_lED,
        borderport_switch
    };
protected:
    Switch::Base switch;
    UMLRTTimerProtocol_baserole timing;
public:
    enum InternalPortId
    {
        internalport_timing
    };
    enum PartId
    {
    };
    enum PortId
    {
        port_lED,
        port_switch,
        port_timing
    };
    virtual void bindPort( bool isBorder, int portId, int index );
    virtual void unbindPort( bool isBorder, int portId, int index );
    virtual void inject( const UMLRTMessage & message );
    virtual void initialize( const UMLRTMessage & message );
    const char * getCurrentStateString() const;
private:
    enum State
    {
        top__ON,
        top__ON__LEDOFF,
        top__OFF,
        top__ON__LEDON,
        SPECIAL_INTERNAL_STATE_UNVISITED
    };
    const char * stateNames[5];
    State currentState;
    State history[1];
    void save_history( State compositeState, State subState );
    bool check_history( State compositeState, State subState );
    void actionchain_____top__ON__new_transition_4__ActionChain20( const UMLRTMessage * msg );
    void actionchain_____top__ON__new_transition_5__ActionChain21( const UMLRTMessage * msg );
    State junction_____top__ON__new_exitpoint_1( const UMLRTMessage * msg );
    State choice_____top__ON__deephistory( const UMLRTMessage * msg );
    State state_____top__OFF( const UMLRTMessage * msg );
    State state_____top__ON__LEDOFF( const UMLRTMessage * msg );
    State state_____top__ON__LEDON( const UMLRTMessage * msg );
};
extern const UMLRTCapsuleClass LEDEmbedded;

#endif

