
#include "LEDIF.hh"

#include "LED.hh"
#include "umlrtcommsportrole.hh"
#include "umlrtmessage.hh"
#include "umlrtslot.hh"
#include <cstddef>
#include "umlrtcapsuleclass.hh"
#include "umlrtframeservice.hh"
class UMLRTRtsInterface;
struct UMLRTCommsPort;

Capsule_LEDIF::Capsule_LEDIF( const UMLRTCapsuleClass * cd, UMLRTSlot * st, const UMLRTCommsPort * * border, const UMLRTCommsPort * * internal, bool isStat )
: UMLRTCapsule( NULL, cd, st, border, internal, isStat )
, lED( borderPorts[borderport_lED] )
, currentState( SPECIAL_INTERNAL_STATE_UNVISITED )
{
    stateNames[top__Running] = "top__Running";
    stateNames[SPECIAL_INTERNAL_STATE_UNVISITED] = "<uninitialized>";
}





void Capsule_LEDIF::bindPort( bool isBorder, int portId, int index )
{
    if( isBorder )
        switch( portId )
        {
        case borderport_lED:
            UMLRTFrameService::sendBoundUnbound( borderPorts, borderport_lED, index, true );
            break;
        }
}

void Capsule_LEDIF::unbindPort( bool isBorder, int portId, int index )
{
    if( isBorder )
        switch( portId )
        {
        case borderport_lED:
            UMLRTFrameService::sendBoundUnbound( borderPorts, borderport_lED, index, false );
            UMLRTFrameService::disconnectPort( borderPorts[borderport_lED], index );
            break;
        }
}

void Capsule_LEDIF::inject( const UMLRTMessage & message )
{
    msg = &message;
    switch( currentState )
    {
    case top__Running:
        currentState = state_____top__Running( &message );
        break;
    default:
        break;
    }
}

void Capsule_LEDIF::initialize( const UMLRTMessage & message )
{
    msg = &message;
    currentState = top__Running;
}

const char * Capsule_LEDIF::getCurrentStateString() const
{
    return stateNames[currentState];
}




void Capsule_LEDIF::transitionaction_____LEDEmbedded__LEDIF__LEDIFSM__Region1__Transition1__Turn_hardware_LED_ON( const UMLRTMessage * msg )
{
    // the following code has been generated
    /* UMLRT-CODEGEN:platform:/resource/Forum_1709295-LEDEmbedded/LEDEmbedded.uml#_76tsoGPzEeWX3sFSul_gHA */
    #define rtdata ( (void *)msg->getParam( 0 ) )
    // generated code ends
    // User code to turn LED off
    // the following code has been generated
    #undef rtdata
    // generated code ends
}

void Capsule_LEDIF::transitionaction_____LEDEmbedded__LEDIF__LEDIFSM__Region1__Transition2__Turn_LED_off( const UMLRTMessage * msg )
{
    // the following code has been generated
    /* UMLRT-CODEGEN:platform:/resource/Forum_1709295-LEDEmbedded/LEDEmbedded.uml#__6dfsGPzEeWX3sFSul_gHA */
    #define rtdata ( (void *)msg->getParam( 0 ) )
    // generated code ends
    // User code to turn LED off
    // the following code has been generated
    #undef rtdata
    // generated code ends
}

void Capsule_LEDIF::actionchain_____top__Transition4__ActionChain6( const UMLRTMessage * msg )
{
    transitionaction_____LEDEmbedded__LEDIF__LEDIFSM__Region1__Transition1__Turn_hardware_LED_ON( msg );
}

void Capsule_LEDIF::actionchain_____top__Transition7__ActionChain9( const UMLRTMessage * msg )
{
    transitionaction_____LEDEmbedded__LEDIF__LEDIFSM__Region1__Transition2__Turn_LED_off( msg );
}

Capsule_LEDIF::State Capsule_LEDIF::state_____top__Running( const UMLRTMessage * msg )
{
    switch( msg->destPort->role()->id )
    {
    case port_lED:
        switch( msg->getSignalId() )
        {
        case LED::signal_lEDON:
            actionchain_____top__Transition4__ActionChain6( msg );
            return top__Running;
        case LED::signal_lEDOFF:
            actionchain_____top__Transition7__ActionChain9( msg );
            return top__Running;
        default:
            this->unexpectedMessage();
            break;
        }
        return currentState;
    default:
        this->unexpectedMessage();
        break;
    }
    return currentState;
}


static const UMLRTCommsPortRole portroles_border[] = 
{
    {
        Capsule_LEDIF::port_lED,
        "LED",
        "lED",
        "",
        1,
        true,
        true,
        false,
        false,
        false,
        false,
        true
    }
};

static void instantiate_LEDIF( const UMLRTRtsInterface * rts, UMLRTSlot * slot, const UMLRTCommsPort * * borderPorts )
{
    slot->capsule = new Capsule_LEDIF( &LEDIF, slot, borderPorts, NULL, false );
}

const UMLRTCapsuleClass LEDIF = 
{
    "LEDIF",
    NULL,
    instantiate_LEDIF,
    0,
    NULL,
    1,
    portroles_border,
    0,
    NULL
};

