
#ifndef LEDIF_HH
#define LEDIF_HH

#include "LED.hh"
#include "umlrtcapsule.hh"
#include "umlrtcapsuleclass.hh"
#include "umlrtmessage.hh"
struct UMLRTCommsPort;
struct UMLRTSlot;

class Capsule_LEDIF : public UMLRTCapsule
{
public:
    Capsule_LEDIF( const UMLRTCapsuleClass * cd, UMLRTSlot * st, const UMLRTCommsPort * * border, const UMLRTCommsPort * * internal, bool isStat );
protected:
    LED::Conj lED;
public:
    enum BorderPortId
    {
        borderport_lED
    };
    enum PartId
    {
    };
    enum PortId
    {
        port_lED
    };
    virtual void bindPort( bool isBorder, int portId, int index );
    virtual void unbindPort( bool isBorder, int portId, int index );
    virtual void inject( const UMLRTMessage & message );
    virtual void initialize( const UMLRTMessage & message );
    const char * getCurrentStateString() const;
private:
    enum State
    {
        top__Running,
        SPECIAL_INTERNAL_STATE_UNVISITED
    };
    const char * stateNames[2];
    State currentState;
    void transitionaction_____LEDEmbedded__LEDIF__LEDIFSM__Region1__Transition1__Turn_hardware_LED_ON( const UMLRTMessage * msg );
    void transitionaction_____LEDEmbedded__LEDIF__LEDIFSM__Region1__Transition2__Turn_LED_off( const UMLRTMessage * msg );
    void actionchain_____top__Transition4__ActionChain6( const UMLRTMessage * msg );
    void actionchain_____top__Transition7__ActionChain9( const UMLRTMessage * msg );
    State state_____top__Running( const UMLRTMessage * msg );
};
extern const UMLRTCapsuleClass LEDIF;

#endif

