
#include "SwitchIF.hh"

#include "umlrtcommsportrole.hh"
#include "umlrtmessage.hh"
#include "umlrtslot.hh"
#include <cstddef>
#include "umlrtcapsuleclass.hh"
#include "umlrtframeservice.hh"
class UMLRTRtsInterface;
struct UMLRTCommsPort;

Capsule_SwitchIF::Capsule_SwitchIF( const UMLRTCapsuleClass * cd, UMLRTSlot * st, const UMLRTCommsPort * * border, const UMLRTCommsPort * * internal, bool isStat )
: UMLRTCapsule( NULL, cd, st, border, internal, isStat )
, switch( borderPorts[borderport_switch] )
, currentState( SPECIAL_INTERNAL_STATE_UNVISITED )
{
    stateNames[top__Running] = "top__Running";
    stateNames[SPECIAL_INTERNAL_STATE_UNVISITED] = "<uninitialized>";
}





void Capsule_SwitchIF::bindPort( bool isBorder, int portId, int index )
{
    if( isBorder )
        switch( portId )
        {
        case borderport_switch:
            UMLRTFrameService::sendBoundUnbound( borderPorts, borderport_switch, index, true );
            break;
        }
}

void Capsule_SwitchIF::unbindPort( bool isBorder, int portId, int index )
{
    if( isBorder )
        switch( portId )
        {
        case borderport_switch:
            UMLRTFrameService::sendBoundUnbound( borderPorts, borderport_switch, index, false );
            UMLRTFrameService::disconnectPort( borderPorts[borderport_switch], index );
            break;
        }
}

void Capsule_SwitchIF::inject( const UMLRTMessage & message )
{
    msg = &message;
    switch( currentState )
    {
    case top__Running:
        currentState = state_____top__Running( &message );
        break;
    default:
        break;
    }
}

void Capsule_SwitchIF::initialize( const UMLRTMessage & message )
{
    msg = &message;
    actionchain_____top__Transition2__ActionChain3( &message );
    currentState = top__Running;
}

const char * Capsule_SwitchIF::getCurrentStateString() const
{
    return stateNames[currentState];
}




void Capsule_SwitchIF::entryaction_____LEDEmbedded__SwitchIF__SwitchIFSM__Region1__Running__HandleSwitchInterrupt( const UMLRTMessage * msg )
{
    // the following code has been generated
    /* UMLRT-CODEGEN:platform:/resource/Forum_1709295-LEDEmbedded/LEDEmbedded.uml#_TmPqoGPwEeWX3sFSul_gHA */
    #define rtdata ( (void *)msg->getParam( 0 ) )
    // generated code ends
    /*

    while (true)
      {
        On switchInterupt  // When a switch state change is detected
          {
            if (switch == ON)  // If the switch is now ON
              {
                switch.SwitchON().send();  // Send the SwitchON message through the switch port
              }
            else if (switch == OFF)
              {
                switch.SwitchOFF().send();  // Send the SwitchOFF message
              }
      }

    */
    // the following code has been generated
    #undef rtdata
    // generated code ends
}

void Capsule_SwitchIF::actionchain_____top__Transition2__ActionChain3( const UMLRTMessage * msg )
{
    entryaction_____LEDEmbedded__SwitchIF__SwitchIFSM__Region1__Running__HandleSwitchInterrupt( msg );
}

Capsule_SwitchIF::State Capsule_SwitchIF::state_____top__Running( const UMLRTMessage * msg )
{
    switch( msg->destPort->role()->id )
    {
    default:
        this->unexpectedMessage();
        break;
    }
    return currentState;
}


static const UMLRTCommsPortRole portroles_border[] = 
{
    {
        Capsule_SwitchIF::port_switch,
        "Switch",
        "switch",
        "",
        1,
        true,
        true,
        false,
        false,
        false,
        false,
        true
    }
};

static void instantiate_SwitchIF( const UMLRTRtsInterface * rts, UMLRTSlot * slot, const UMLRTCommsPort * * borderPorts )
{
    slot->capsule = new Capsule_SwitchIF( &SwitchIF, slot, borderPorts, NULL, false );
}

const UMLRTCapsuleClass SwitchIF = 
{
    "SwitchIF",
    NULL,
    instantiate_SwitchIF,
    0,
    NULL,
    1,
    portroles_border,
    0,
    NULL
};

