
#ifndef SWITCHIF_HH
#define SWITCHIF_HH

#include "Switch.hh"
#include "umlrtcapsule.hh"
#include "umlrtcapsuleclass.hh"
#include "umlrtmessage.hh"
struct UMLRTCommsPort;
struct UMLRTSlot;

class Capsule_SwitchIF : public UMLRTCapsule
{
public:
    Capsule_SwitchIF( const UMLRTCapsuleClass * cd, UMLRTSlot * st, const UMLRTCommsPort * * border, const UMLRTCommsPort * * internal, bool isStat );
protected:
    Switch::Conj switch;
public:
    enum BorderPortId
    {
        borderport_switch
    };
    enum PartId
    {
    };
    enum PortId
    {
        port_switch
    };
    virtual void bindPort( bool isBorder, int portId, int index );
    virtual void unbindPort( bool isBorder, int portId, int index );
    virtual void inject( const UMLRTMessage & message );
    virtual void initialize( const UMLRTMessage & message );
    const char * getCurrentStateString() const;
private:
    enum State
    {
        top__Running,
        SPECIAL_INTERNAL_STATE_UNVISITED
    };
    const char * stateNames[2];
    State currentState;
    void entryaction_____LEDEmbedded__SwitchIF__SwitchIFSM__Region1__Running__HandleSwitchInterrupt( const UMLRTMessage * msg );
    void actionchain_____top__Transition2__ActionChain3( const UMLRTMessage * msg );
    State state_____top__Running( const UMLRTMessage * msg );
};
extern const UMLRTCapsuleClass SwitchIF;

#endif

