
#include "Template.hh"

#include "umlrtslot.hh"
#include <cstddef>
#include "umlrtcapsuleclass.hh"
#include "umlrtmessage.hh"
class UMLRTRtsInterface;
struct UMLRTCommsPort;

Capsule_Template::Capsule_Template( const UMLRTCapsuleClass * cd, UMLRTSlot * st, const UMLRTCommsPort * * border, const UMLRTCommsPort * * internal, bool isStat )
: UMLRTCapsule( NULL, cd, st, border, internal, isStat )
, currentState( SPECIAL_INTERNAL_STATE_UNVISITED )
{
    stateNames[SPECIAL_INTERNAL_STATE_UNVISITED] = "<uninitialized>";
}


void Capsule_Template::bindPort( bool isBorder, int portId, int index )
{
}

void Capsule_Template::unbindPort( bool isBorder, int portId, int index )
{
}

void Capsule_Template::inject( const UMLRTMessage & message )
{
    msg = &message;
    switch( currentState )
    {
    default:
        break;
    }
}

void Capsule_Template::initialize( const UMLRTMessage & message )
{
    msg = &message;
}

const char * Capsule_Template::getCurrentStateString() const
{
    return stateNames[currentState];
}





static void instantiate_Template( const UMLRTRtsInterface * rts, UMLRTSlot * slot, const UMLRTCommsPort * * borderPorts )
{
    slot->capsule = new Capsule_Template( &Template, slot, borderPorts, NULL, false );
}

const UMLRTCapsuleClass Template = 
{
    "Template",
    NULL,
    instantiate_Template,
    0,
    NULL,
    0,
    NULL,
    0,
    NULL
};

