
#include "Top.hh"

#include "LEDEmbedded.hh"
#include "LEDIF.hh"
#include "SwitchIF.hh"
#include "umlrtcapsuleclass.hh"
#include "umlrtcapsulepart.hh"
#include "umlrtframeservice.hh"
#include "umlrtslot.hh"
#include <cstddef>
#include "umlrtcapsulerole.hh"
class UMLRTRtsInterface;
struct UMLRTCommsPort;

Capsule_Top::Capsule_Top( const UMLRTCapsuleClass * cd, UMLRTSlot * st, const UMLRTCommsPort * * border, const UMLRTCommsPort * * internal, bool isStat )
: UMLRTCapsule( NULL, cd, st, border, internal, isStat )
, lEDEmbedded( &slot->parts[part_lEDEmbedded] )
, lEDIF( &slot->parts[part_lEDIF] )
, switchIF( &slot->parts[part_switchIF] )
{
}





void Capsule_Top::bindPort( bool isBorder, int portId, int index )
{
}

void Capsule_Top::unbindPort( bool isBorder, int portId, int index )
{
}

void Capsule_Top::initialize( const UMLRTMessage & msg )
{
}

void Capsule_Top::inject( const UMLRTMessage & msg )
{
}


static const UMLRTCapsuleRole roles[] = 
{
    {
        "lEDEmbedded",
        &LEDEmbedded,
        1,
        1,
        false,
        false
    },
    {
        "lEDIF",
        &LEDIF,
        1,
        1,
        false,
        false
    },
    {
        "switchIF",
        &SwitchIF,
        1,
        1,
        false,
        false
    }
};

static void instantiate_Top( const UMLRTRtsInterface * rts, UMLRTSlot * slot, const UMLRTCommsPort * * borderPorts )
{
    LEDEmbedded.instantiate( NULL, slot->parts[Capsule_Top::part_lEDEmbedded].slots[0], UMLRTFrameService::createBorderPorts( slot->parts[Capsule_Top::part_lEDEmbedded].slots[0], LEDEmbedded.numPortRolesBorder ) );
    LEDIF.instantiate( NULL, slot->parts[Capsule_Top::part_lEDIF].slots[0], UMLRTFrameService::createBorderPorts( slot->parts[Capsule_Top::part_lEDIF].slots[0], LEDIF.numPortRolesBorder ) );
    SwitchIF.instantiate( NULL, slot->parts[Capsule_Top::part_switchIF].slots[0], UMLRTFrameService::createBorderPorts( slot->parts[Capsule_Top::part_switchIF].slots[0], SwitchIF.numPortRolesBorder ) );
    slot->capsule = new Capsule_Top( &Top, slot, borderPorts, NULL, false );
}

const UMLRTCapsuleClass Top = 
{
    "Top",
    NULL,
    instantiate_Top,
    3,
    roles,
    0,
    NULL,
    0,
    NULL
};

