
#include "TopControllers.hh"

#include "LEDEmbedded.hh"
#include "LEDIF.hh"
#include "SwitchIF.hh"
#include "Top.hh"
#include "umlrtcapsuleclass.hh"
#include "umlrtcapsulepart.hh"
#include "umlrtcommsport.hh"
#include "umlrtcommsportfarend.hh"
#include "umlrtcontroller.hh"
#include "umlrtslot.hh"
#include <cstddef>


UMLRTController DefaultController( "DefaultController" );

static Capsule_Top top( &Top, &Top_slots[InstId_Top], NULL, NULL, true );

static UMLRTSlot * slots_Top[] = 
{
    &Top_slots[InstId_Top_lEDEmbedded],
    &Top_slots[InstId_Top_lEDIF],
    &Top_slots[InstId_Top_switchIF]
};

static UMLRTCapsulePart parts_Top[] = 
{
    {
        &Top,
        Capsule_Top::part_lEDEmbedded,
        1,
        &slots_Top[0]
    },
    {
        &Top,
        Capsule_Top::part_lEDIF,
        1,
        &slots_Top[1]
    },
    {
        &Top,
        Capsule_Top::part_switchIF,
        1,
        &slots_Top[2]
    }
};

static UMLRTCommsPortFarEnd borderfarEndList_Top_lEDEmbedded[] = 
{
    {
        0,
        NULL
    },
    {
        0,
        NULL
    }
};

UMLRTCommsPort borderports_Top_lEDEmbedded[] = 
{
    {
        &LEDEmbedded,
        Capsule_LEDEmbedded::borderport_lED,
        &Top_slots[InstId_Top_lEDEmbedded],
        1,
        borderfarEndList_Top_lEDEmbedded,
        NULL,
        NULL,
        "",
        true,
        true,
        true,
        false,
        false,
        false,
        false,
        false,
        false,
        false,
        true
    },
    {
        &LEDEmbedded,
        Capsule_LEDEmbedded::borderport_switch,
        &Top_slots[InstId_Top_lEDEmbedded],
        1,
        &borderfarEndList_Top_lEDEmbedded[1],
        NULL,
        NULL,
        "",
        true,
        true,
        true,
        false,
        false,
        false,
        false,
        false,
        false,
        false,
        true
    }
};

static const UMLRTCommsPort * borderports_Top_lEDEmbedded_ptrs[] = 
{
    &borderports_Top_lEDEmbedded[0],
    &borderports_Top_lEDEmbedded[1]
};

static UMLRTCommsPortFarEnd internalfarEndList_Top_lEDEmbedded[] = 
{
    {
        0,
        NULL
    }
};

UMLRTCommsPort internalports_Top_lEDEmbedded[] = 
{
    {
        &LEDEmbedded,
        Capsule_LEDEmbedded::internalport_timing,
        &Top_slots[InstId_Top_lEDEmbedded],
        1,
        internalfarEndList_Top_lEDEmbedded,
        NULL,
        NULL,
        "",
        true,
        false,
        true,
        false,
        false,
        false,
        false,
        false,
        false,
        false,
        true
    }
};

static const UMLRTCommsPort * internalports_Top_lEDEmbedded_ptrs[] = 
{
    &internalports_Top_lEDEmbedded[0]
};

static Capsule_LEDEmbedded top_lEDEmbedded( &LEDEmbedded, &Top_slots[InstId_Top_lEDEmbedded], borderports_Top_lEDEmbedded_ptrs, internalports_Top_lEDEmbedded_ptrs, true );

static UMLRTCommsPortFarEnd borderfarEndList_Top_lEDIF[] = 
{
    {
        0,
        NULL
    }
};

UMLRTCommsPort borderports_Top_lEDIF[] = 
{
    {
        &LEDIF,
        Capsule_LEDIF::borderport_lED,
        &Top_slots[InstId_Top_lEDIF],
        1,
        borderfarEndList_Top_lEDIF,
        NULL,
        NULL,
        "",
        true,
        true,
        true,
        false,
        false,
        false,
        false,
        false,
        false,
        false,
        true
    }
};

static const UMLRTCommsPort * borderports_Top_lEDIF_ptrs[] = 
{
    &borderports_Top_lEDIF[0]
};

static Capsule_LEDIF top_lEDIF( &LEDIF, &Top_slots[InstId_Top_lEDIF], borderports_Top_lEDIF_ptrs, NULL, true );

static UMLRTCommsPortFarEnd borderfarEndList_Top_switchIF[] = 
{
    {
        0,
        NULL
    }
};

UMLRTCommsPort borderports_Top_switchIF[] = 
{
    {
        &SwitchIF,
        Capsule_SwitchIF::borderport_switch,
        &Top_slots[InstId_Top_switchIF],
        1,
        borderfarEndList_Top_switchIF,
        NULL,
        NULL,
        "",
        true,
        true,
        true,
        false,
        false,
        false,
        false,
        false,
        false,
        false,
        true
    }
};

static const UMLRTCommsPort * borderports_Top_switchIF_ptrs[] = 
{
    &borderports_Top_switchIF[0]
};

static Capsule_SwitchIF top_switchIF( &SwitchIF, &Top_slots[InstId_Top_switchIF], borderports_Top_switchIF_ptrs, NULL, true );

UMLRTSlot Top_slots[] = 
{
    {
        "Top",
        0,
        &Top,
        NULL,
        0,
        &top,
        &DefaultController,
        3,
        parts_Top,
        0,
        NULL,
        NULL,
        true,
        false
    },
    {
        "Top.lEDEmbedded",
        0,
        &LEDEmbedded,
        &Top,
        Capsule_Top::part_lEDEmbedded,
        &top_lEDEmbedded,
        &DefaultController,
        0,
        NULL,
        2,
        borderports_Top_lEDEmbedded,
        NULL,
        true,
        false
    },
    {
        "Top.lEDIF",
        0,
        &LEDIF,
        &Top,
        Capsule_Top::part_lEDIF,
        &top_lEDIF,
        &DefaultController,
        0,
        NULL,
        1,
        borderports_Top_lEDIF,
        NULL,
        true,
        false
    },
    {
        "Top.switchIF",
        0,
        &SwitchIF,
        &Top,
        Capsule_Top::part_switchIF,
        &top_switchIF,
        &DefaultController,
        0,
        NULL,
        1,
        borderports_Top_switchIF,
        NULL,
        true,
        false
    }
};

